/* ultoa_fast() test with table of patterns.  Basis are: 8,10,16.
   Prefix is checked.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

/* Compare with pattern.	*/
static int cmp (unsigned long val, int base, const char * pattern)
{
    char s[13];
    char *p;
    
    p = ultoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;
    return 0;
}

int main ()
{
    static struct t_s {
	unsigned long val;
	int base;
	char s[13];		/* pattern	*/
    } t[] = {

	/* prefix for octal	*/
	{ 0, 8 | XTOA_PREFIX,		"0" },
	{ 1, 8 | XTOA_PREFIX,		"01" },
	{ 8, 8 | XTOA_PREFIX,		"010" },
	{ -1, 8 | XTOA_PREFIX,		"037777777777" },
	
	/* prefix for hex	*/
	{ 0, 16 | XTOA_PREFIX,		"0" },
	{ 1, 16 | XTOA_PREFIX,		"0x1" },
	{ 16, 16 | XTOA_PREFIX,		"0x10" },
	{ -1, 16 | XTOA_PREFIX,		"0xffffffff" },
	
	/* upper for hex	*/
	{ 0,        16 | XTOA_UPPER | XTOA_PREFIX,	"0" },
	{ 0xabcdef, 16 | XTOA_UPPER,			"ABCDEF" },
	{ 0xabcdef, 16 | XTOA_UPPER | XTOA_PREFIX,	"0XABCDEF" },
	{ 0x2,      16 | XTOA_UPPER | XTOA_PREFIX,	"0X2" },

    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->base, p->s))
	    exit(i);
    }
    
    return 0;
}
