/* Decimal conversion with a set of values: 1..3 bits, 1..3 holes.
   'strtoul' is used for result verification.    */
#include <ctype.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

void run (unsigned long val)
{
    char s[11];
    char *p;

    p = ultoa_fast (val, s, 10);
    if (p != s) exit(__LINE__);
    if (!isdigit(s[0])) exit(__LINE__);
    if (val) {
        if (s[0] == '0') exit(__LINE__);
    } else {
        if (strlen(s) != 1) exit(__LINE__);
    }
    if (strtoul(s, &p, 10) != val) exit(__LINE__);
    if (p == s || *p) exit(__LINE__);   /* error or invalid character   */
}

int main ()
{
    unsigned long v1, v2, v3;
    
    /* 1..3 bits are set	*/
    for (v1 = 1; v1; v1 <<= 1)
    for (v2 = 1; v2; v2 <<= 1)
    for (v3 = 1; v3; v3 <<= 1)
	run (v1 | v2 | v3);

    /* 1..3 bits are clean	*/
    for (v1 = ~1L; v1 != ~0Lu; v1 = (v1 << 1) + 1)
    for (v2 = ~1L; v2 != ~0Lu; v2 = (v2 << 1) + 1)
    for (v3 = ~1L; v3 != ~0Lu; v3 = (v3 << 1) + 1)
	run (v1 & v2 & v3);

    return 0;
}
