/* ultoa_width() test with table of patterns. Base is 10.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

#define SIZEMAX     13

/* Compare with pattern.	*/
static int cmp (unsigned long val, size_t width, const char * pattern)
{
    char s[SIZEMAX];
    char *p;
    
    p = ultoa_width (val, s, 10, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	unsigned long val;
	unsigned char width;
	char s[SIZEMAX];
    } t[] = {

	{ 0, 0,		"0" },
	{ 0, 1,		"0" },
	{ 0, 2,		" 0" },
	{ 0, 12,	"           0" },
	
	{ 1, 0,		"1" },
	{ 1, 1,		"1" },
	{ 1, 2,		" 1" },
	{ 1, 12,	"           1" },
	
	{ -1, 10,	"4294967295" },
	{ -1, 11,	" 4294967295" },
	{ -1, 12,	"  4294967295" },
	
	{ 10, 3,		" 10" },
	{ 100, 4,		" 100" },
	{ 1000, 5,		" 1000" },
	{ 10000, 6,		" 10000" },
	{ 100000, 7,		" 100000" },
	{ 1000000, 8,		" 1000000" },
	{ 10000000, 9,		" 10000000" },
	{ 100000000, 10,	" 100000000" },
	{ 1000000000, 11,	" 1000000000" },

    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->width, p->s))
	    exit(i);
    }
    
    return 0;
}
