/* (u)ltoa_width() test with table of patterns. Base is 8.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

#define SIZEMAX     14

/* Compare with pattern.	*/
static int
cmp (unsigned long val, int flags, size_t width, const char * pattern)
{
    char s[SIZEMAX];
    char *p;
    
    p = ltoa_width (val, s, flags | 8, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = ultoa_width (val, s, flags | 8, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	long val;
	int flags;
	unsigned char width;
	char s[SIZEMAX];
    } t[] = {

	{ 0, 0, 0,	"0" },
	{ 0, 0, 1,	"0" },
	{ 0, 0, 2,	"00" },
	{ 0, 0, 13,	"0000000000000" },
	
	{ 1, 0, 0,	"1" },
	{ 1, 0, 1,	"1" },
	{ 1, 0, 2,	"01" },
	{ 1, 0, 13,	"0000000000001" },
	
	{ -1, 0, 11,	"37777777777" },
	{ -1, 0, 12,	"037777777777" },
	
	{ 010, 0, 3,		"010" },
	{ 010000000000, 0, 12,	"010000000000" },
	
	{ 0, XTOA_PREFIX, 0,	"0" },
	{ 0, XTOA_PREFIX, 1,	"0" },
	{ 0, XTOA_PREFIX, 2,	"00" },
	
	{ 1, XTOA_PREFIX, 0,	"01" },
	{ 1, XTOA_PREFIX, 1,	"01" },
	{ 1, XTOA_PREFIX, 2,	"01" },
	{ 1, XTOA_PREFIX, 3,	"001" },
	
	{ -1, XTOA_PREFIX, 12,	"037777777777" },
	{ -1, XTOA_PREFIX, 13,	"0037777777777" },
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->flags, p->width, p->s))
	    exit(i);
    }
    
    return 0;
}
