/* Printf hex, int.
 */
#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void run (unsigned x, int upper)
{
    char s [sizeof("ffff")];
    unsigned char r1;
    size_t n;
    unsigned long y;
    char *p;
    
    x &= 0xffff;		/* for "test of test"	*/
    sprintf (s, upper ? "%X" : "%x", x);
    
#ifdef	TEST_OF_TEST
    (void)r1;
#else
    /* r1 ? (it is used in asm subroutine)	*/
    asm ("mov %0,r1" : "=r"(r1));
    if (r1) exit (__LINE__);
#endif

    /* strlen(s) ?	*/
    n = strlen(s);
    if (x < 0x10) {
	if (n != 1) exit (__LINE__);
    } else if (x < 0x100) {
	if (n != 2) exit (__LINE__);
    } else if (x < 0x1000) {
	if (n != 3) exit (__LINE__);
    } else {
	if (n != 4) exit (__LINE__);
    }

    /* back ?	*/
    errno = 0;
    y = strtoul(s, & p, 16);
    if (errno || *p) exit (__LINE__);
    if (y != x) exit (__LINE__);
    
    /* upper ?	*/
    for (p= s; *p; p++) {
	if (isalpha(*p)) {
	    if (upper) {
		if (islower(*p)) exit(__LINE__);
	    } else {
		if (isupper(*p)) exit(__LINE__);
	    }
	}
    }
}

void run2 (unsigned x)
{
    run (x, 0);
    run (x, 1);
    run (~x, 0);
    run (~x, 1);
}

int main ()
{
    unsigned int x;
    int i;

    run2 (0);
    run2 (0x1234);
    run2 (0x5555);
    
    for (x= 1; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 3; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 7; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 0xf; x & 0xffff; x <<= 1)
	run2 (x);

    for (x= 0, i= 15; i; i--)
	run2 (x += 0x1111);

    for (x= 0; x <= 0x20; x++)
	run2 (x);
    for (x= 0xffff; x >= 0xffe0; x--)
	run2 (x);

    srand (5);
    for (i= 100; i; i--)
	run2 (rand());

    return 0;
}
